#!/usr/bin/perl

require "./LuxSci_API2.pm";

my $token  = "Uo+E2COSdJ6POOA3ka8HQQMqK7sxgeuuX7+I3xaxSzk";
my $secret = "QR0AkY4RfFloBsfonV71/Yhd+43RJh7VpAA1wyxH87Q";
my $user   = 'user@domain.com';
my $host   = "rest.luxsci.com";

my $api = new LuxSci_API2(
      secret  => $secret,
      token   => $token,
      host    => $host,
      debug   => 0,
      );

my ($code, $data) = @{ $api->getLastResponse() };
if ($code >= 300) {
	die "Auhentication faled: $$data{error_message}\n";
	}

##
## Example of calling sendEmail API endpoint.
##

my ($response_data, $status, $msg) = do_call_api( $api, "POST",
      "/perl/api/v2/user/$user/email/send",
      {
      messages => [{
         to => [ 'mailnull@luxsci.net' ],
         subject => "API smtp test",
         from_name => "API Test",
         from_address => $user,
         body => "Test message"
         }]
      });

my $id = $$response_data{data}[0];

print "Message sent: Sendmail_id=[$id]\n\n";


sub do_call_api {
   my ($api, $method, $path, $data) = @_;

   $api->call( method => $method, path => $path, data => $data );

   my ($code, $xdata) = @{ $api->getLastResponse() };

   if ($code >= 300) {
      die "Failed: code=$code; error=$$xdata{error_message}\n"
      }

   return ($xdata, 1);
   }
